package nl.sbdeveloper.themeparkplus.api.objects;

import com.sk89q.worldedit.regions.Region;
import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;
import org.bukkit.Location;

import java.util.ArrayList;

@NoArgsConstructor @AllArgsConstructor
public class WaitingRow {
    @Getter @Setter private String rideID;
    @Getter @Setter private Region region;
    @Getter @Setter private int waitingPlayers = 0;
    @Getter @Setter private double waitingTimeMinutes = 0;
    private ArrayList<Location> signLocations = new ArrayList<>();

    public WaitingRow(String rideID, Region region) {
        this.rideID = rideID;
        this.region = region;
    }

    public ArrayList<Location> getSignLocations() {
        return signLocations;
    }

    public void addSignLocation(Location loc) {
        this.signLocations.add(loc);
    }

    public void removeSignLocation(Location loc) {
        this.signLocations.remove(loc);
    }
}
