package nl.sbdeveloper.themeparkplus.listeners;

import com.sk89q.worldedit.regions.Region;
import me.paradoxpixel.themepark.api.API;
import nl.sbdeveloper.themeparkplus.ThemeParkPlus;
import nl.sbdeveloper.themeparkplus.api.PlusAPI;
import nl.sbdeveloper.themeparkplus.api.objects.WaitingRow;
import nl.sbdeveloper.themeparkplus.util.ConfigUtil;
import org.bukkit.block.BlockState;
import org.bukkit.block.Sign;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.block.BlockBreakEvent;
import org.bukkit.event.block.SignChangeEvent;
import org.jetbrains.annotations.NotNull;

import java.util.Collections;
import java.util.Optional;

/**
 * Sign setup listener
 */
public class SignListeners implements Listener {
    /*
    [ThemeParkPlus]
    XXXX
    <RideName>
    XXXX
     */

    @EventHandler
    public void onCreate(@NotNull SignChangeEvent e) {
        Player p = e.getPlayer();
        String[] lines = e.getLines();

        //Only check themeparkplus signs!
        if (!lines[0].equalsIgnoreCase("[ThemeParkPlus]")) return;

        if (!p.hasPermission("tpp.fastpass.create")) {
            p.sendMessage(ConfigUtil.getMessage("General.NoPermission"));
            return;
        }

        if (!API.isAttraction(e.getLine(2))) {
            p.sendMessage(ConfigUtil.getMessage("Fastpass.UnknownRide", Collections.singletonMap("ridename", e.getLine(2))));
            return;
        }

        String mLineOne = ConfigUtil.makecolored(ThemeParkPlus.getSConfig().getFile().getString("Fastpass.MachineSign.Row1"));
        String mLineTwo = ConfigUtil.makecolored(ThemeParkPlus.getSConfig().getFile().getString("Fastpass.MachineSign.Row2"));
        String sLineOne = ConfigUtil.makecolored(ThemeParkPlus.getSConfig().getFile().getString("Fastpass.ScannerSign.Row1"));
        String sLineTwo = ConfigUtil.makecolored(ThemeParkPlus.getSConfig().getFile().getString("Fastpass.ScannerSign.Row2"));
        String wrLineOne = ConfigUtil.makecolored(ThemeParkPlus.getSConfig().getFile().getString("WaitingRow.Sign.Row1"));
        String wrLineTwo = ConfigUtil.makecolored(ThemeParkPlus.getSConfig().getFile().getString("WaitingRow.Sign.Row2"));

        if (lines[1].equalsIgnoreCase("Machine") && !lines[2].isEmpty() && !lines[3].isEmpty()) {
            e.setLine(0, mLineOne);
            e.setLine(1, mLineTwo);
        } else if (lines[1].equalsIgnoreCase("Scanner") && !lines[2].isEmpty() && !lines[3].isEmpty()) {
            e.setLine(0, sLineOne);
            e.setLine(1, sLineTwo);
        } else if (lines[1].equalsIgnoreCase("WaitingRow") && !lines[2].isEmpty() && !lines[3].isEmpty()) {
            e.setLine(0, wrLineOne);
            e.setLine(1, wrLineTwo);

            Region selected = ThemeParkPlus.getWEUtil().getSelection(p);

            //AND SETUP
            WaitingRow row = new WaitingRow(lines[2], selected);
            PlusAPI.addRow(row);
            ThemeParkPlus.getData().save();

            p.sendMessage(ConfigUtil.getMessage("WaitingRow.SignCreated"));
        } else {
            p.sendMessage(ConfigUtil.getMessage("General.IncorrectSign"));
        }
    }

    @EventHandler
    public void onDestroySign(BlockBreakEvent e) {
        BlockState signblocks = e.getBlock().getState();
        if ((signblocks instanceof Sign)) {
            Optional<WaitingRow> rowOptional = PlusAPI.getRowBySign(e.getBlock().getLocation());
            if (!rowOptional.isPresent()) return;

            WaitingRow row = rowOptional.get();
            if (row.getSignLocations().size() == 1) {
                PlusAPI.removeRow(row);
            } else {
                row.getSignLocations().remove(e.getBlock().getLocation());
            }
            ThemeParkPlus.getData().save();
        }
    }
}
