package nl.sbdeveloper.themeparkplus.listeners;

import nl.sbdeveloper.themeparkplus.ThemeParkPlus;
import nl.sbdeveloper.themeparkplus.api.PlusAPI;
import nl.sbdeveloper.themeparkplus.api.objects.WaitingRow;
import nl.sbdeveloper.themeparkplus.util.ConfigUtil;
import org.bukkit.Bukkit;
import org.bukkit.Location;
import org.bukkit.block.Block;
import org.bukkit.block.BlockState;
import org.bukkit.block.Sign;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.player.PlayerMoveEvent;
import org.jetbrains.annotations.NotNull;

import java.util.Collections;
import java.util.Optional;

public class WaitingTimeListener implements Listener {

    private static final double PER_PLAYER = ThemeParkPlus.getSConfig().getFile().getDouble("WaitingRow.MinutesPerPlayer");

    @EventHandler
    public void onPlayerMove(@NotNull PlayerMoveEvent e) {
        if (e.getTo() == null) return;
        if ((e.getFrom().getBlockX() != e.getTo().getBlockX())
                || (e.getFrom().getBlockY() != e.getTo().getBlockY())
                || (e.getFrom().getBlockZ() != e.getTo().getBlockZ())) {
            Optional<WaitingRow> rowOptional = PlusAPI.getRow(e.getFrom());
            Optional<WaitingRow> rowOptional2 = PlusAPI.getRow(e.getTo());

            WaitingRow row = null;
            int waitingNew = 0;
            double waitingTimeNew = 0;
            if (!rowOptional.isPresent() && rowOptional2.isPresent()) {
                //ENTER
                row = rowOptional2.get();
                waitingNew = row.getWaitingPlayers() + 1;
                waitingTimeNew = row.getWaitingTimeMinutes() + PER_PLAYER;
            } else if (rowOptional.isPresent() && !rowOptional2.isPresent()) {
                //LEAVE
                row = rowOptional.get();
                waitingNew = row.getWaitingPlayers() - 1;
                waitingTimeNew = row.getWaitingTimeMinutes() - PER_PLAYER;
            }

            if (row == null) return;

            row.setWaitingPlayers(waitingNew);
            row.setWaitingTimeMinutes(waitingTimeNew);

            for (Location location : row.getSignLocations()) {
                Block signblock = location.getBlock();
                BlockState signblocks = signblock.getState();
                if ((signblocks instanceof Sign)) {
                    Sign signs = (Sign) signblocks;
                    signs.setLine(3, waitingNew + " min.");
                    signs.update();
                } else {
                    Bukkit.getLogger().warning(ConfigUtil.getMessage("WaitingRow.WrongLocation", Collections.singletonMap("%ridename%", row.getRideID())));
                    PlusAPI.removeRow(row);
                    ThemeParkPlus.getData().save();
                }
            }
        }
    }
}
