package nl.sbdeveloper.themeparkplus.util;

import com.sk89q.worldedit.IncompleteRegionException;
import com.sk89q.worldedit.LocalSession;
import com.sk89q.worldedit.bukkit.WorldEditPlugin;
import com.sk89q.worldedit.regions.Region;
import com.sk89q.worldedit.regions.RegionSelector;
import org.bukkit.Bukkit;
import org.bukkit.entity.Player;
import org.jetbrains.annotations.Nullable;

public class WEUtil {
    private static WorldEditPlugin wep;

    public WEUtil() {
        wep = (WorldEditPlugin) Bukkit.getPluginManager().getPlugin("WorldEdit");
    }

    @Nullable
    public Region getSelection(Player p) {
        LocalSession session;
        try {
            session = wep.getSession(p);
        } catch (Exception e) {
            // sometimes after a reload getSession create errors with WorldEdit, this prevent error spam
            return null;
        }

        return getSelectedRegion(session);
    }

    @Nullable
    private Region getSelectedRegion(@Nullable LocalSession session) {
        if (session != null && session.getSelectionWorld() != null) {
            RegionSelector selector = session.getRegionSelector(session.getSelectionWorld());

            if (selector.isDefined()) {
                try {
                    return selector.getRegion();
                } catch (IncompleteRegionException e) {
                    Bukkit.getLogger().warning("[ThemeParkPlus] Region still incomplete");
                }
            }
        }
        return null;
    }
}
